



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android学习之基础知识九 — 数据存储（持久化技术）之SQLite数据库存储</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android学习之基础知识九 — 数据存储（持久化技术）之SQLite数据库存储</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 03:18:27 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　前面一讲介绍了数据持久化技术的前两种：文件存储、SharedPreferences存储。下面介绍第三种技术：SQLite数据库存储</p>
<p><strong>一、SQLite数据库存储</strong></p>
<p>　　SQLite数据库是一款轻量级的关系型数据库，它的运算速度非常快，占用资源很少，通常只需要几百KB的内存就足够了，因而特别适合在移动设备上使用。SQLite不仅支持标准的SQL语法，还遵循了数据库的ACID事务，所以只要你以前使用过其他的关系型数据库，就能很快上手。而SQLite又比一般的数据库要简单的得多，它甚至不用设置用户名和密码就可以使用。Android正是把这个功能极为强大的数据库嵌入到了系统当中，成为了Android系统的内置数据库，使得本地持久化的功能有了一次质的飞跃。</p>
<p>　　前面我们所学的文件存储和SharedPreferences存储毕竟只适用于保存一些简单的数据和键值对，当需要存储大量复杂的关系型数据的时候，这两种存储方式就很难应付了，这时候就需要使用到SQLite数据库。</p>
<p><strong>1.1、创建数据库（SQLiteOpenHelper帮助类）</strong></p>
<p>　　Android为了让我们更加方便地管理数据库，专门提供了一个SQLiteOpenHelper帮助类，借助这个类我们可以非常简单的对数据库进行创建和升级。下面就来介绍一下SQLiteOpenHelper的基本用法。</p>
<p>　　1、首先需要知道SQLiteOpenHelper是一个抽象类，这意味着如果我们想要使用它的话，就需要创建一个自己的帮助类去继承它，SQLiteOpenHelper中有两个抽象方法，分别是：onCreate(）方法和 onUpgrade(）方法，我们必须在自己的帮助类中重写这两个方法，然后分别在这两个方法中去实现创建、升级数据库的逻辑。</p>
<p>　　2、SQLiteOpenHelper中还有两个非常重要的实例方法：getReadableDatabase(）和getWritableDatabase(）。这两个方法都可以创建或打开一个现有的数据库（如果数据库已经存在则直接打开，否则创建一个新的数据库），并返回一个对数据库进行读写操作的对象，不同的是，当数据库不可写入的时候（如磁盘空间已满），getReadableDatabase(）方法返回的对象将以只读的方式去打开数据库，而getWritableDatabase(）方法则将出现异常。</p>
<p>　　3、SQLiteOpenHelper中有两个构造方法可供重写，一般使用参数少一点的那个构造方法即可。这个构造方法中接收4个参数，第一个参数是Context，这个没什么好说的，必须要有它才能对数据库进行操作；第二个参数是数据库名，创建数据库时使用的就是这里指定的名称；第三个参数允许我们在查询数据的时候返回一个自定义的Cursor，一般都是传入null；第四个参数表示当前数据库的版本号，可用于对数据库进行升级操作。构建出SQLiteOpenHelper的实例后，再调用它的：getReadableDatabase(）或getWritableDatabase(）方法就能创建数据库了，数据库文件会存放在：/data/data/程序包名/databases/目录下。此时，重写的onCreate(）方法也会得到执行，所以通常会在这里去处理一些创建表的逻辑。</p>
<p>接下来我们就通过实际的例子来直观的体会一下SQLiteOpenHelper的用法吧。</p>
<p>　　这里我们希望创建一个名为BookStore.db的数据库，然后在这个数据库中新建一张Book表，表中有id（主键）、作者、价格、页数和书名等列，创建数据库表当然还是需要用建表语句的，Book表的建表语句如下所示：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215112939706-1885682969.png" /></p>
<p>　　SQLite不像其他数据库拥有众多复杂的数据类型，它的数据类型很简单，integer表示整型，real表示浮点型，text表示文本类型，blob表示二进制类型。另外我们还使用了primary&nbsp;key将id设置为主键，并用autoincrement关键字表示id列是自增长的。</p>
<p>然后我们开始写代码：</p>
<p>第一步：新建MyDatabaseHelper类继承SQLiteOpenHelper</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215132925282-291354690.png" /></p>
<p>第二步：设置一个按钮，用于实现点击按钮创建数据库和建表的功能</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215133148552-663133295.png" /></p>
<p>第三步：在MainActivity中实现数据库和表的创建</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215133536892-1157825379.png" /></p>
<p>第四步：运行程序，点击按钮，弹出一个创建成功的Toast提示，说明数据库和表我们都已经创建完成了。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215134016774-401817489.png" /></p>
<p>数据库和表都创建完成后，我们知道它是保存在：/data/data/com.workspace.hh.databasetest/databases目录下，如果还是使用File Explorer打开，我们只会看到一个BookStore.db文件，看不到Book表，这里我们换一个打开方式来查看数据库和Book表，就是使用adb&nbsp;shell来对数据库和表的创建情况进行检测。</p>
<p>　　adb是Android&nbsp;SDK中自带的一个调试工具，使用这个工具可以直接对连接在电脑上的手机或模拟器进行调试操作，它存放在sdk的platform-tools目录下，如果想要在命令行中使用这个工具，就需要先把它的路径配置到环境变量中。打开计算机 ---&gt;&nbsp;属性 ---&gt;&nbsp;高级系统设置 ---&gt;&nbsp;环境变量，然后在系统变量中找到Path并点击编辑，将platform-tools目录配置进去，如图所示：<br /><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215135549250-1478930076.png" /></p>
<p>配置完成后，就可以使用adb工具了：</p>
<p>　　（1）打开Android&nbsp;Studio中的Terminal工具：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215135825453-1948309956.png" /></p>
<p>　　（2）输入：adb shell，回车，进入到设备的控制台</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215140149303-60141820.png" /></p>
<p>　　（3）使用cd命令进入到db文件的目录：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215140415339-1203973099.png" /></p>
<p>　　（4）使用：ls命令来查看该目录里的文件：该目录下出现了两个数据库文件，一个正是我们的创建的BookStore.db，而另外一个BookStore.db-journal则是为了让数据库能够支持事务而产生的临时日志文件，通常情况下这个文件的大小都是0字节。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215140542787-286204996.png" /></p>
<p>　　（5）借助sqlite命令来打开数据库：sqlite3&nbsp;BookStore.db</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215141055484-520226660.png" /></p>
<p>　　（6）打开数据库后，就可以对这个数据库中的表进行管理了，首先我们看一下数据库中有哪些表：(<strong>.table</strong>)</p>
<p>可以看到数据库中有两张表，android_metadata表示每个数据库中都会自动生成的，不用管它，而另外一张book表就是我们创建的了。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215141330067-1703819279.png" /></p>
<p>　　（7）通过（<strong>.schema</strong>）命令来查看它们的建表语句：从建表语句中我们可以看出，数据库和表已经创建完成了。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215141738820-1574166096.png" /></p>
<p>　　（8）通过（<strong>.exit</strong>）或（<strong>.quit</strong>）命令退出数据库的编辑，然后再通过（<strong>exit</strong>）命令退出设备的控制台</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215142339001-2127755211.png" /></p>
<p><strong>1.2、升级数据库</strong></p>
<p>　　在上面MyDatabaseHelper中还保留了一个：onUpgrade(）方法，这个方法就是用于对数据库进行升级的，它在整个数据库的管理工作中起着非常重要的作用。目前DatabaseTest项目中已经存在一张Book表用于存放书的各种详细数据，接着我们再添加一张Category表用于记录图书的分类，Category表中有id（主键）、分类名个分类代码这几列，建表语句如下：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215145233035-488763856.png" /></p>
<p>现在我们开始在代码中进行建表：</p>
<p>第一步：修改MyDatabaseHelper中的代码：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215152136786-339955945.png" /></p>
<p>第二步：要执行：onUpgrade(）方法，只需要输入一个比当前数据库的版本号大的版本号就行了</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215152550242-351914095.png" /></p>
<p>第三步：运行程序，点击按钮，我们看到有Toast提示弹出，接着我们检查数据库中是否成功创建了Category表，发现建表成功。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215152914524-1887262902.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215152945186-328516304.png" /></p>
<p><strong>1.3、添加数据</strong></p>
<p>　　&nbsp;我们对数据库的操纵无非就4种：CRUD，即：Create添加、Retrieve查询、Update更新、Delete删除。每一种操作都各自对应了一种SQL命令：添加用insert、查询用select、更新用update、删除用delete；Android提供了一系列的辅助方法，使得在Android中即使不去编写SQL语句，也能轻松完成所有的CRUD操作。</p>
<p>　　前面我们已经知道，调用SQLiteOpenHelper的：getReadableDatabase(）或getWritableDatabase(）方法是可以用于创建和升级数据库的，不仅如此，这两个方法还都会返回一个SQLiteDatabase对象，借助这个对象我们就可以对数据进行CRUD操作了。</p>
<p>　　SQLiteDatabase中提供了一个：insert(）方法，这个方法就是专门用于添加数据的，它接收3个参数，第一个参数是表名，向哪个表添加数据，就是传入哪个表的名字；第二个参数是用于在未指定添加数据的情况下给某些可为空的列自动赋值NULL，一般我们用不到这个功能，直接传入null即可；第三个参数是一个ContentValues对象，它提供一系列的：put(）方法重载，用于向ContentValues中添加数据，只需要将表中的每个列名以及相应的待添加数据传入即可。</p>
<p>下面就提高例子来亲自体验一下添加数据的操作：</p>
<p>第一步：创建一个按钮，通过点击按钮来添加数据</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215161829435-2129544654.png" /></p>
<p>第二步：在MainActivity中实现添加数据的操作：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215164410744-557834047.png" /></p>
<p>第三步：运行程序，看到有添加数据成功的提示信息，然后通过：<strong>(select * from book；）</strong>查询语句查看添加的两条数据（注意查询语句后面有分号）</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215164905483-738350129.png" /></p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181215165808541-1775904546.png" /></p>
<p><strong>&nbsp;1.4、更新数据</strong></p>
<p>　　SQLiteDatabase中也提供了一个非常好用的：update(）方法，用于对数据进行更新，这个方法接收4个参数，第一个参数个insert(）方法一样，也是表名，指定去更新哪张表里的数据。第二个参数是ContentValues对象，要把更新的数据在这里组装进去。第三、第四个参数用于约束更新某一行或某几行中的数据，不指定的话默认就是更新所有行。</p>
<p>第一步：创建一个按钮，通过点击按钮实现数据更新</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181225105920551-984117682.png" /></p>
<p>第二步：在MainActivity中实现业务逻辑</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181225113341804-543088980.png" /></p>
<p>第三步：运行程序，点击按钮，在Terminal中查看是否更新成功</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181225113519601-1240492411.png" />&nbsp;<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181225113612459-1289349814.png" /></p>
<p><strong>1.5、删除数据</strong></p>
<p>　　SQLiteDatabase中提供了一个：delete(）方法，专门用于删除数据，这个方法接收三个参数，第一个参数仍然是表名，第二、三个参数又是用于约束删除某一行或几行的数据，不指定的话默认就是删除所有行。</p>
<p>第一步：添加一个删除按钮，通过点击按钮来删除数据</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181226093955717-1438692454.png" /></p>
<p>第二步：在MainActivity中实现功能</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181226094022294-53527922.png" /></p>
<p>第三步：运行程序，点击按钮，然后查看book表中的数据是否被删除，从查询的数据中，我们可以看出，页数为899的&ldquo;The&nbsp;mental&nbsp;of&nbsp;Java&rdquo;这本书已经被删除。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181226094106351-1516671727.png" />&nbsp;<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181226094352624-2072722308.png" /></p>
<p><strong>1.6、查询数据</strong></p>
<p>　　SQLite的全称是：Structured&nbsp;Query&nbsp;Language，翻译成中文就是结构化查询语言，它的大部分功能都体现在&ldquo;查&rdquo;这个字上，而&ldquo;增删改&rdquo;只是其中的一小部分功能。SQLiteDatabase中还提供了一个：query(）方法用于对数据进行查询，这个方法的参数非常的复杂，最短的一个方法重载也需要传入7个参数，这7个参数的含义是：</p>
<p>　　第一个参数：表名，即我们希望在哪张表中查询数据</p>
<p>　　第二个参数：指定去哪儿查询哪几列，如果不指定则默认查询所有列</p>
<p>　　第三、四个参数：约束查询某一行或某几行的数据，不指定则默认查询所有行的数据</p>
<p>　　第五个参数：指定需要去group&nbsp;by的列，不指定则表示不对查询结果进行group&nbsp;by操作</p>
<p>　　第六个参数：对group&nbsp;by之后的数据进行进一步的过滤，不指定则表示不进行过滤</p>
<p>　　第七个参数：指定查询结果的排序方式，不指定则表示使用默认的排序方式。</p>
<p>具体的内容可参照下表：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181226131917011-1864695883.png" /></p>
<p>虽然：query(）方法的参数非常多，但是我们不必为每条查询语句都指定所有的参数，多数情况下只需要传入少数几个参数就可以完成查询操作了。调用query(）方法后会返回一个Cursor对象，查询到的所有数据都将从这个对象中取出。接下来我们就通过一个简单的例子来体验数据的查询操作：</p>
<p>第一步：创建一个按钮，通过点击按钮来查询数据</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181226135312410-926847964.png" /></p>
<p>第二步：在MainActivity中实现功能逻辑</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181226135633513-1492346981.png" /></p>
<p>第三步：打印出查询到数据</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181226135707087-1341590390.png" /></p>
<p><strong>1.7、使用SQL操作数据库</strong></p>
<p>　　Android提供了一系列方法可以直接通过SQL来操作数据库，上面的CRUD操作可以用下面的SQL语句来完成：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1505274/201812/1505274-20181226141825439-1527801759.png" /></p>
<p>　　除了查询语句的时候调用的是SQLiteDatabase的：rawQuery(）方法，其他操作都是调用：execSQL(）方法。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2n66vq.html">2016年10月30日--JavaScript语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1n6e49.html">iOS 关于AFNetworking ssl 待完成</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8opk7eq.html">NYOJ题目611练练</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ke7x78.html">iOS  Swipe Tableviewcell&lpar;左右滑动出现按钮&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1eg149.html">javascript第四弹&mdash;&mdash;变量、作用域、内存</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdee6w09.html">libpcap文件格式分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnepyoq.html">简单学习：repo入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxneynz8.html">PHP使用外部命令导出数据库，备份到服务器并下载到本地</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxne0ed8.html">jqueryGrid 内置的onclickSubmit  afterSubmit</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okgppp9.html">QTableWidget嵌入QpushButton后定位是哪一个QpushButton</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmwy3e9.html">安装oracle 11g详细过程仅供参考</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oker759.html">关于升级到win10后的网络问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zog2xvq.html">tomcat配置管理用户名密码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp1gpr9.html">微信支付&period;net官方坑太多，我们来精简</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdxvj79.html">android 透明状态栏方法及其适配键盘上推（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y15dw8.html">最简单的基于FFMPEG&plus;SDL的音频播放器 ver2 （采用SDL2&period;0）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy17w5dq.html">Mongodb---操作备忘</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy171pxq.html">MAC下Intellij IDEA常用快捷键</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyn42k9.html">安装需要的第三方库时，命令行输入pip提示不是内部或外部命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r2nz39.html">linux学习笔记整理（七）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pwv7zy8.html">POJ 1113 Wall&lpar;思维 计算几何 数学&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjddoj9.html">typedef struct LNode命名结构指针（线性表的链式存储）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwvep48.html">Java网络编程--InetAdress类</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwvy348.html">android recovery代码修改之原生建议</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwxv4j9.html">使用EWS API读取邮件</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r15x39.html">iptable用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyl7dd9.html">将爬取的数据保存到mysql中</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r1xdj9.html">oh-my-zsh安装与使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gjx7l79.html">数据分组、统计   case when then else end</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvlonk8.html">if语句（初学者）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
